Loading...
Searching...
No Matches
tagged_encoder.h
Go to the documentation of this file.
/* -*- c++ -*- */
/*
* Copyright 2014 Free Software Foundation, Inc.
*
* This file is part of GNU Radio
*
* SPDX-License-Identifier: GPL-3.0-or-later
*
*/
#ifndef INCLUDED_FEC_TAGGED_ENCODER_H
#define INCLUDED_FEC_TAGGED_ENCODER_H
#include <gnuradio/fec/api.h>
#include <gnuradio/fec/generic_encoder.h>
#include <gnuradio/tagged_stream_block.h>
#include <memory>
namespace gr {
namespace fec {
/*!
* \brief Creates the encoder block for use in GNU Radio
* flowgraphs from a given FECAPI object derived from the
* generic_encoder class.
* \ingroup error_coding_blk
*
* \details
*
* Generally, we would use the fec.extended_encoder Python
* implementation to instantiate this. The extended_encoder wraps
* up a few more details, like taking care of puncturing as well
* as the encoder itself.
*/
class FEC_API tagged_encoder : virtual public tagged_stream_block
{
public:
typedef std::shared_ptr<tagged_encoder> sptr;
/*!
* Build the FEC encoder block from an FECAPI encoder object.
*
* \param my_encoder An FECAPI encoder object child of the generic_encoder class.
* \param input_item_size size of a block of data for the encoder.
* \param output_item_size size of a block of data the encoder will produce.
* \param lengthtagname Key name of the tagged stream frame size.
* \param mtu The Maximum Transmission Unit (MTU) of the input
* frame that the block will be able to
* process. Specified in bytes and defaults to 1500.
*/
static sptr make(generic_encoder::sptr my_encoder,
size_t input_item_size,
size_t output_item_size,
const std::string& lengthtagname = "packet_len",
int mtu = 1500);
int work(int noutput_items,
gr_vector_int& ninput_items,
gr_vector_const_void_star& input_items,
gr_vector_void_star& output_items) override = 0;
int calculate_output_stream_length(const gr_vector_int& ninput_items) override = 0;
};
} /* namespace fec */
} /* namespace gr */
#endif /* INCLUDED_FEC_TAGGED_ENCODER_H */
gr::fec::generic_encoder::sptr
std::shared_ptr< generic_encoder > sptr
Definition generic_encoder.h:37
gr::fec::tagged_encoder
Creates the encoder block for use in GNU Radio flowgraphs from a given FECAPI object derived from the...
Definition tagged_encoder.h:36
gr::fec::tagged_encoder::sptr
std::shared_ptr< tagged_encoder > sptr
Definition tagged_encoder.h:38
gr::fec::tagged_encoder::work
int work(int noutput_items, gr_vector_int &ninput_items, gr_vector_const_void_star &input_items, gr_vector_void_star &output_items) override=0
Just like gr::block::general_work, but makes sure the input is valid.
gr::fec::tagged_encoder::calculate_output_stream_length
int calculate_output_stream_length(const gr_vector_int &ninput_items) override=0
Calculate the number of output items.
gr::fec::tagged_encoder::make
static sptr make(generic_encoder::sptr my_encoder, size_t input_item_size, size_t output_item_size, const std::string &lengthtagname="packet_len", int mtu=1500)
gr::tagged_stream_block
Block that operates on PDUs in form of tagged streams.
Definition tagged_stream_block.h:26
std::vector< int >
generic_encoder.h
api.h
FEC_API
#define FEC_API
Definition gr-fec/include/gnuradio/fec/api.h:18
gr
GNU Radio logging wrapper.
Definition basic_block.h:29
tagged_stream_block.h